;#########################################################################
;		Assembler directives

.486
.model flat,stdcall
option casemap:none

;#########################################################################
;		Include file

include CodeComplete.inc

.code

;#########################################################################
;		Common AddIn Procedures

DllEntry proc hInst:HINSTANCE, reason:DWORD, reserved1:DWORD
	mov eax, hInst
	mov hInstance, eax
	mov eax, TRUE
	ret
DllEntry Endp

; Export this proc (it is autoexported if MakeDef is enabled with option 2)
InstallDll proc uses ebx hWin:DWORD, fOpt:DWORD
	mov	ebx,hWin

	;Get pointer to handles struct
	invoke SendMessage,ebx,AIM_GETHANDLES,0,0;	
	mov	lpHandles,eax

	;Get handle of unsorted popup listbox
	mov eax,[eax].ADDINHANDLES.hLBU
	mov hLB,eax
	;Get pointer to proc struct
	invoke SendMessage,ebx,AIM_GETPROCS,0,0
	mov	lpProc,eax

	;Get pointer to data struct
	invoke SendMessage,ebx,AIM_GETDATA,0,0	
	mov	lpData,eax

	; If Option (fOpt) = 0 then exit
	mov eax,fOpt
	test eax,eax
	je @F
		; Messages to hook into
		mov eax,RAM_EDITOPEN or RAM_MDIACTIVATE

	@@:
	; ECX and EDX must be null before we return
	xor ecx, ecx
	xor edx, edx
	ret 

InstallDll Endp

IsLineCoInvoke proc uses esi edi

	mov		esi,offset linebuff
	mov		edi,offset szCoInvoke
	dec		esi
  @@:
	inc		esi
	mov		al,[esi]
	cmp		al,VK_SPACE
	je		@b
	cmp		al,VK_TAB
	je		@b
	dec		esi
	dec		edi
  @@:
	inc		esi
	inc		edi
	movzx	eax,byte ptr [edi]
	or		eax,eax
	je		@f
	cmp		al,[esi]
	je		@b
  @@:
	ret

IsLineCoInvoke endp

MdiChildProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	pt:POINT

	.if uMsg==WM_NOTIFY
		push	ebx
		;Get pointer to RASELCHANGE structure
		mov		ebx,lParam
		;Check if it is SEL_TEXT notification
		.if [ebx].RASELCHANGE.seltyp==SEL_TEXT
			mov		eax,[ebx].RASELCHANGE.line
			.if eax!=nLine || [ebx].RASELCHANGE.fchanged
				mov		nLine,eax
				;Hide the listbox
				.if fLB
					invoke ShowWindow,hLB,SW_HIDE
					mov		fLB,FALSE
				.endif
				;Get the line text
				push	esi
				push	edi
				mov		esi,[ebx].RASELCHANGE.lpLine
				mov		ecx,[esi].CHARS.len
				lea		esi,[esi+sizeof CHARS]
				mov		edi,offset linebuff
				rep movsb
				;Zero terminate line
				mov		byte ptr [edi],0
				.if byte ptr [edi-1]==VK_RETURN
					;Dont want CR
					mov		byte ptr [edi-1],0
				.endif
				invoke IsLineCoInvoke
				.if !eax
					invoke SendMessage,hLB,LB_RESETCONTENT,0,0
					;put some text into listbox
					push	esi
					mov		esi,offset szSomeText
					.while byte ptr [esi]
						invoke SendMessage,hLB,LB_ADDSTRING,0,esi
						invoke lstrlen,esi
						lea		esi,[esi+eax+1]
					.endw
					pop		esi
					;Set listbox position
					invoke GetCaretPos,addr pt
					invoke GetFocus
					mov		edx,eax
					invoke ClientToScreen,edx,addr pt
					add		pt.y,20
					invoke MoveWindow,hLB,pt.x,pt.y,200,150,FALSE
					;Show listbox
					invoke ShowWindow,hLB,SW_SHOWNA
					invoke SendMessage,hLB,LB_SETCURSEL,0,0
					mov		fLB,TRUE
					;Just to test
					invoke TextOutput,offset linebuff
				.endif
				pop		edi
				pop		esi
			.endif
		.endif
		pop		ebx
	.endif
	invoke CallWindowProc,OldMdiChildProc,hWin,uMsg,wParam,lParam
	ret

MdiChildProc endp

EditProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	buffer[64]:BYTE

	.if uMsg==WM_KEYDOWN
		mov		edx,wParam
		mov		eax,lParam
		shr		eax,16
		and		eax,3FFh
		.if edx==28h && (eax==150h || eax==50h)
			;Down
			.if fLB
				invoke SendMessage,hLB,LB_SETCURSEL,1,0
				invoke SetFocus,hLB
				xor		eax,eax
				jmp		Ex
			.endif
		.endif
	.elseif uMsg==WM_CHAR
		mov		eax,wParam
		.if eax==VK_TAB && fLB
			invoke SendMessage,hLB,LB_GETCURSEL,0,0
			.if eax!=LB_ERR
				mov		edx,eax
				invoke SendMessage,hLB,LB_GETTEXT,edx,addr buffer
				invoke GetParent,hWin
				mov		edx,eax
				invoke SendMessage,edx,EM_REPLACESEL,TRUE,addr buffer
			.endif
			xor		eax,eax
			jmp		Ex
		.else
			.if eax==VK_ESCAPE && fLB
				;Hide listbox
				invoke ShowWindow,hLB,SW_HIDE
				xor		eax,eax
				jmp		Ex
			.endif
			invoke CallWindowProc,OldEditProc,hWin,uMsg,wParam,lParam
			push	eax
			.if fLB
				;Show listbox
				invoke ShowWindow,hLB,SW_SHOWNA
			.endif
			pop		eax
			jmp		Ex
		.endif
	.endif
	invoke CallWindowProc,OldEditProc,hWin,uMsg,wParam,lParam
  Ex:
	ret

EditProc endp

; Export this proc (it is autoexported if MakeDef is enabled with option 2)
DllProc proc hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	; This proc handles messages sent from RadASM to our dll
	; Return TRUE to prevent RadASM and other DLL's from

	mov	eax, uMsg
	.if eax == AIM_EDITOPEN
		;Always return false
		;hWin		handle of mdi child window
		;wParam		handle of RAEdit
		;Check if it is a code edit mdi child
		invoke GetWindowLong,hWin,0
		.if eax==ID_EDIT
			;Subclass the mdi child
			invoke SetWindowLong,hWin,GWL_WNDPROC,offset MdiChildProc
			mov OldMdiChildProc,eax
			;Subclass the RAEdit window
			invoke GetWindowLong,hWin,GWL_USERDATA
			invoke SendMessage,eax,REM_SUBCLASS,0,offset EditProc
			mov OldEditProc,eax
		.endif
	.elseif eax == AIM_MDIACTIVATE
		;A new edit window is selected, reset flags and hide listbox
		xor		eax,eax
		dec		eax
		mov		nLine,eax
		mov		nPos,eax
		.if fLB
			invoke ShowWindow,hLB,SW_HIDE
			mov		fLB,FALSE
		.endif
	.endif
	xor eax,eax
	ret
DllProc Endp

;#########################################################################

End DllEntry
